Index: issm/trunk/src/c/classes/Profiler.h
===================================================================
--- issm/trunk/src/c/classes/Profiler.h	(revision 23389)
+++ issm/trunk/src/c/classes/Profiler.h	(revision 23394)
@@ -11,21 +11,33 @@
 
 /*Macros*/
-#define TOTAL 0      /*Profiling Total time */ 
-#define MPROCESSOR 1 /*Profiling Model processor*/ 
-#define CORE 2       /*Profiling solution */ 
-#define SOLVER 3     /*Profiling solution */ 
-#define ADCORE 4     /*Profiling AD */ 
-#define MAXIMUMSIZE 5
+#define TOTAL              0 /*Profiling Total time */
+#define MPROCESSOR         1 /*Profiling Model processor*/
+#define CORE               2 /*Profiling solution */
+#define SOLVER             3 /*Profiling solution */
+#define ADCORE             4 /*Profiling AD */
+#define THERMALCORE			5 /*Profiling THERMAL */
+#define HYDROLOGYCORE		6 /*Profiling HYDROLOGY */
+#define STRESSBALANCECORE	7 /*Profiling STRESSBALANCE */
+#define DAMAGECORE			8 /*Profiling DAMAGE */
+#define MOVINGFRONTCORE		9 /*Profiling MOVINGFRONT */
+#define MASSTRANSPORTCORE	10 /*Profiling MASSTRANSPORT */
+#define SMBCORE				11 /*Profiling SMB */
+#define GROUNDINGLINECORE	12 /*Profiling GROUDINGLINE MIGRATION */
+#define GIACORE				13 /*Profiling GIA */
+#define ESACORE				14 /*Profiling ESA */
+#define SLRCORE				15 /*Profiling SLR */
+#define MAXPROFSIZE			16 /*Used to initialize static arrays*/
 
 class Profiler: public Object{
 
 	public: 
-		IssmPDouble flops[MAXIMUMSIZE];
-		IssmPDouble flops_start[MAXIMUMSIZE];
-		IssmPDouble memory[MAXIMUMSIZE];
-		IssmPDouble memory_start[MAXIMUMSIZE];
-		IssmPDouble time[MAXIMUMSIZE];
-		IssmPDouble time_start[MAXIMUMSIZE];
-		bool        running[MAXIMUMSIZE];
+		IssmPDouble flops[MAXPROFSIZE];
+		IssmPDouble flops_start[MAXPROFSIZE];
+		IssmPDouble memory[MAXPROFSIZE];
+		IssmPDouble memory_start[MAXPROFSIZE];
+		IssmPDouble time[MAXPROFSIZE];
+		IssmPDouble time_start[MAXPROFSIZE];
+		bool        running[MAXPROFSIZE];
+		bool        used[MAXPROFSIZE];
 
 		/*Profiler constructors, destructors */
@@ -48,6 +60,7 @@
 		int          TotalTimeModSec(int tag);
 		IssmPDouble  Memory(int tag);
-		void         Start(int tagenum,bool dontmpisync=false);
-		void         Stop(int tagenum,bool dontmpisync=false);
+		void         Start(int tagenum,bool dontmpisync=true); /*Do not call MPI barrier by default to save some ms*/
+		void         Stop(int tagenum, bool dontmpisync=true); /*Do not call MPI barrier by default to save some ms*/
+		bool         Used(int tagenum);
 };
 
Index: issm/trunk/src/c/cores/ad_core.cpp
===================================================================
--- issm/trunk/src/c/cores/ad_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/ad_core.cpp	(revision 23394)
@@ -19,4 +19,7 @@
 /*}}}*/
 
+#ifdef _HAVE_CODIPACK_
+CoDi_global codi_global = {};
+#endif
 void ad_core(FemModel* femmodel){
 
@@ -41,5 +44,5 @@
 	if(isautodiff && !iscontrol){
 
-		#ifdef _HAVE_ADOLC_
+		#if defined(_HAVE_ADOLC_)
 			if(VerboseAutodiff())_printf0_("   start ad core\n");
 
@@ -318,4 +321,65 @@
 			xDelete(axp); 
 			xDelete(driver);
+
+			#elif defined(_HAVE_CODIPACK_)
+			if(VerboseAutodiff())_printf0_("   start CoDiPack ad core\n");
+
+			/*First, stop tracing: */
+			auto& tape_codi = IssmDouble::getGlobalTape();
+			tape_codi.setPassive();
+
+			if(VerboseAutodiff()){ /*{{{*/
+				if(my_rank == 0) {
+					// FIXME codi "just because" for now
+					tape_codi.printStatistics(std::cout);
+					codi_global.print(std::cout);
+				}
+			}
+
+			/*retrieve parameters: */
+			femmodel->parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
+			femmodel->parameters->FindParam(&num_independents,AutodiffNumIndependentsEnum);
+
+			/*if no dependents, no point in running a driver: */
+			if(!(num_dependents*num_independents)) return;
+
+			/*Branch according to AD driver: */
+			femmodel->parameters->FindParam(&driver,AutodiffDriverEnum);
+			if(VerboseAutodiff())_printf0_("   driver: " << driver << "\n");
+
+			if (strcmp(driver,"fos_reverse")==0) { /*{{{*/
+				if(VerboseAutodiff())_printf0_("   CoDiPack fos_reverse\n");
+				int     aDepIndex=0;
+				double *weightVectorTimesJac=NULL;
+
+				/*retrieve direction index: */
+				femmodel->parameters->FindParam(&aDepIndex,AutodiffFosReverseIndexEnum);
+				if (my_rank==0) {
+					if (aDepIndex<0 || aDepIndex>=num_dependents
+							|| codi_global.output_indices.size() <= aDepIndex){
+						_error_("index value for AutodiffFosReverseIndexEnum should be in [0,num_dependents-1]");
+					}
+					tape_codi.setGradient(codi_global.output_indices[aDepIndex], 1.0);
+				}
+
+				tape_codi.evaluate();
+
+				weightVectorTimesJac=xNew<double>(num_independents);
+				/*call driver: */
+				auto in_size = codi_global.input_indices.size();
+				for(size_t i = 0; i < in_size; ++i) {
+					weightVectorTimesJac[i] = tape_codi.getGradient(codi_global.input_indices[i]);
+				}
+
+				/*add to results*/
+				femmodel->results->AddObject(new GenericExternalResult<IssmPDouble*>(femmodel->results->Size()+1,AutodiffJacobianEnum,weightVectorTimesJac,num_independents,1,0,0.0));
+
+				/*free resources :*/
+				xDelete(weightVectorTimesJac);
+			} /*}}}*/
+			else _error_("driver: " << driver << " not yet supported!");
+
+			if(VerboseAutodiff())_printf0_("   end CoDiPack ad core\n");
+			xDelete(driver);
 		#else
 			_error_("Should not be requesting AD drivers when an AD library is not available!");
Index: issm/trunk/src/c/cores/adgradient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/adgradient_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/adgradient_core.cpp	(revision 23394)
@@ -48,5 +48,5 @@
 	if(isautodiff){
 
-		#ifdef _HAVE_ADOLC_
+		#if defined(_HAVE_ADOLC_)
 			if(VerboseAutodiff())_printf0_("   start ad core\n"); 
 
@@ -182,4 +182,7 @@
 			xDelete(totalgradient);
 			xDelete(axp); /*}}}*/
+
+		#elif defined(_HAVE_CODIPACK_)
+			fprintf(stderr, "*** Codipack adgradient_core()\n");
 		#else
 			_error_("Should not be requesting AD drivers when an AD library is not available!");
Index: issm/trunk/src/c/cores/adjointstressbalance_core.cpp
===================================================================
--- issm/trunk/src/c/cores/adjointstressbalance_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/adjointstressbalance_core.cpp	(revision 23394)
@@ -31,7 +31,18 @@
 	if(VerboseSolution()) _printf0_("   computing velocities\n");
 	femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
+	
+	bool is_schur_cg_solver = false;
+	#ifdef _HAVE_PETSC_
+	int solver_type;
+	PetscOptionsDetermineSolverType(&solver_type);
+
+	if(solver_type==FSSolverEnum) is_schur_cg_solver = true;
+	#endif
+
 	if(isFS){
 		if (fe_FS==LATaylorHoodEnum || fe_FS==LACrouzeixRaviartEnum)
 		 solutionsequence_la(femmodel);
+		else if(is_schur_cg_solver)
+		 solutionsequence_schurcg(femmodel);
 		else
 		 solutionsequence_nonlinear(femmodel,conserve_loads); 
Index: issm/trunk/src/c/cores/control_core.cpp
===================================================================
--- issm/trunk/src/c/cores/control_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/control_core.cpp	(revision 23394)
@@ -81,6 +81,6 @@
 	IssmDouble  *XL = NULL;
 	IssmDouble  *XU = NULL;
-	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
-	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	GetVectorFromControlInputsx(&XL,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
 	for(long i=0;i<nsize;i++){
 		if(X0[i]>XU[i]) X0[i]=XU[i];
@@ -97,5 +97,5 @@
 		femmodel->OutputControlsx(&femmodel->results);
 
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
 		IssmPDouble* J_passive=xNew<IssmPDouble>(nsteps);
 		for(int i=0;i<nsteps;i++) J_passive[i]=reCast<IssmPDouble>(J[i]);
@@ -134,6 +134,6 @@
 	IssmDouble  *XL = NULL;
 	IssmDouble  *XU = NULL;
-	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
-	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	GetVectorFromControlInputsx(&XL,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
 	for(long i=0;i<nsize;i++){
 		if(X[i]>XU[i]) X[i]=XU[i];
@@ -143,5 +143,6 @@
 	/*Update control input*/
 	SetControlInputsFromVectorx(femmodel,X);
-
+	
+	
 	/*solve forward: */
 	switch(solution_type){
@@ -150,8 +151,21 @@
 			stressbalance_core(femmodel);	//We need a 3D velocity!! (vz is required for the next thermal run)
 			break;
-		case StressbalanceSolutionEnum:
+		case StressbalanceSolutionEnum:{
 			femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
-			solutionsequence_nonlinear(femmodel,conserve_loads); 
-			break;
+			
+			bool is_schur_cg_solver = false;
+			#ifdef _HAVE_PETSC_
+			int solver_type;
+			PetscOptionsDetermineSolverType(&solver_type);
+			if(solver_type==FSSolverEnum) is_schur_cg_solver = true;
+			#endif
+			
+			if(is_schur_cg_solver){
+			 solutionsequence_schurcg(femmodel);
+			}else{
+			 solutionsequence_nonlinear(femmodel,conserve_loads); 
+			}
+			}
+			 break;
 		case BalancethicknessSolutionEnum:
 			femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum);
@@ -211,6 +225,6 @@
 	IssmDouble  *XL = NULL;
 	IssmDouble  *XU = NULL;
-	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
-	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	GetVectorFromControlInputsx(&XL,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
 	for(long i=0;i<nsize;i++){
 		if(X[i]>XU[i]) X[i]=XU[i];
Index: issm/trunk/src/c/cores/controlad_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controlad_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/controlad_core.cpp	(revision 23394)
@@ -11,4 +11,5 @@
 #include "../solutionsequences/solutionsequences.h"
 
+/*This file is probably never used!*/
 #if defined (_HAVE_M1QN3_)  & defined (_HAVE_ADOLC_)
 /*m1qn3 prototypes {{{*/
Index: issm/trunk/src/c/cores/controladm1qn3_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controladm1qn3_core.cpp	(revision 23389)
+++ issm/trunk/src/c/cores/controladm1qn3_core.cpp	(revision 23394)
@@ -11,6 +11,11 @@
 #include "../solutionsequences/solutionsequences.h"
 
-#if defined (_HAVE_M1QN3_) && defined(_HAVE_ADOLC_)
-/*m1qn3 prototypes*/
+#ifdef _HAVE_CODIPACK_
+extern CoDi_global codi_global;
+#include <sstream> // for output of the CoDiPack tape
+#endif
+
+#if defined (_HAVE_M1QN3_) && defined(_HAVE_AD_)
+/*m1qn3 prototypes {{{*/
 extern "C" void *ctonbe_; // DIS mode : Conversion
 extern "C" void *ctcabe_; // DIS mode : Conversion
@@ -31,8 +36,10 @@
 	int*         i;
 } m1qn3_struct;
+/*}}}*/
 
 /*m1qm3 functions*/
 void simul_starttrace(FemModel* femmodel){/*{{{*/
 
+	#if defined(_HAVE_ADOLC_)
 	/*Retrive ADOLC parameters*/
 	IssmDouble gcTriggerRatio;
@@ -57,114 +64,48 @@
 	int my_rank=IssmComm::GetRank();
 	trace_on(my_rank,keepTaylors,reCast<size_t>(obufsize),reCast<size_t>(lbufsize),reCast<size_t>(cbufsize),reCast<size_t>(tbufsize),skipFileDeletion);
+
+	#elif defined(_HAVE_CODIPACK_)
+
+		//fprintf(stderr, "*** Codipack IoModel::StartTrace\n");
+		/*
+		 * FIXME codi
+		 * - ADOL-C variant uses fine grained tracing with various arguments
+		 * - ADOL-C variant sets a garbage collection parameter for its tape
+		 * -> These parameters are not read for the CoDiPack ISSM version!
+		 */
+		auto& tape_codi = IssmDouble::getGlobalTape();
+		tape_codi.setActive();
+		#if _AD_TAPE_ALLOC_
+		//alloc_profiler.Tag(StartInit, true);
+		IssmDouble x_t(1.0), y_t(1.0);
+		tape_codi.registerInput(y_t);
+		int codi_allocn = 0;
+		femmodel->parameters->FindParam(&codi_allocn,AutodiffTapeAllocEnum);
+		for(int i = 0;i < codi_allocn;++i) {
+			x_t = y_t * y_t;
+		}
+		/*
+		std::stringstream out_s;
+		IssmDouble::getGlobalTape().printStatistics(out_s);
+		_printf0_("StartTrace::Tape Statistics	   : TapeAlloc count=[" << codi_allocn << "]\n" << out_s.str());
+		*/
+		tape_codi.reset();
+		//alloc_profiler.Tag(FinishInit, true);
+		#else
+		tape_codi.reset();
+		#endif
+
+	#else
+	_error_("not implemented");
+	#endif
 }/*}}}*/
-void simul_ad(long* indic,long* n,double* X,double* pf,double* G,long izs[1],float rzs[1],void* dzs){/*{{{*/
-
-	/*Get rank*/
-	int my_rank=IssmComm::GetRank();
-
-	/*Recover Arguments*/
-	m1qn3_struct *input_struct = (m1qn3_struct*)dzs;
-
-	FemModel* femmodel = input_struct->femmodel;
-	int num_responses,num_controls,numberofvertices,solution_type;
-	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
-	int* N = NULL;
-	int N_add = 0;
-	int* control_enum = NULL;
-
-	if (solution_type == TransientSolutionEnum){
-		femmodel = input_struct->femmodel->copy();
-	}
-
-	IssmPDouble*  Jlist        = input_struct->Jlist;
-	int           JlistM       = input_struct->M;
-	int           JlistN       = input_struct->N;
-	int*          Jlisti       = input_struct->i;
-	int           intn         = (int)*n;
-
-	/*Recover some parameters*/
-	IssmDouble* scaling_factors = NULL;
-	femmodel->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
-	femmodel->parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
-	femmodel->parameters->FindParam(&scaling_factors,NULL,InversionControlScalingFactorsEnum);
-	femmodel->parameters->FindParam(&N,NULL,ControlInputSizeNEnum);
-	femmodel->parameters->FindParam(&control_enum,NULL,InversionControlParametersEnum);
-	numberofvertices=femmodel->vertices->NumberOfVertices();
-
-	/*Constrain input vector and update controls*/
-	double  *XL = NULL;
-	double  *XU = NULL;
-	GetPassiveVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
-	GetPassiveVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
-
-	N_add = 0;
-	for (int c=0;c<num_controls;c++){
-		for(int i=0;i<numberofvertices*N[c];i++){
-			int index = N_add*numberofvertices+i;
-			X[index] = X[index]*reCast<double>(scaling_factors[c]);
-			if(X[index]>XU[index]) X[index]=XU[index];
-			if(X[index]<XL[index]) X[index]=XL[index];
-		}
-		N_add+=N[c];
-	}
-
-	/*Start Tracing*/
-	simul_starttrace(femmodel);
-	/*Set X as our new control input and as INDEPENDENT*/
-#ifdef _HAVE_AD_
-	IssmDouble* aX=xNew<IssmDouble>(intn,"t");
-#else
-	IssmDouble* aX=xNew<IssmDouble>(intn);
-#endif
-	if(my_rank==0){
-		for(int i=0;i<intn;i++){
-			aX[i]<<=X[i];
-		}
-	}
-
-	ISSM_MPI_Bcast(aX,intn,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
-	SetControlInputsFromVectorx(femmodel,aX);
-	xDelete<IssmDouble>(aX);
-
-	/*Compute solution (forward)*/
-	void (*solutioncore)(FemModel*)=NULL;
-	CorePointerFromSolutionEnum(&solutioncore,femmodel->parameters,solution_type);
-	solutioncore(femmodel);
-
-	/*Reset the time to zero for next optimization*/
-	if(solution_type==TransientSolutionEnum){
-		IssmDouble restart_time;
-		femmodel->parameters->FindParam(&restart_time,TimesteppingStartTimeEnum);
-		femmodel->parameters->SetParam(restart_time,TimeEnum);
-
-	}
-
-	/*Get Dependents*/
-	IssmDouble  output_value;
-	int         num_dependents;
-	IssmPDouble *dependents;
-	DataSet*    dependent_objects=NULL;
-	IssmDouble	J=0.;
-	femmodel->parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
-	femmodel->parameters->FindParam(&dependent_objects,AutodiffDependentObjectsEnum);
-
-	/*Go through our dependent variables, and compute the response:*/
-	dependents=xNew<IssmPDouble>(num_dependents);
-	for(int i=0;i<dependent_objects->Size();i++){
-		DependentObject* dep=(DependentObject*)dependent_objects->GetObjectByOffset(i);
-		if(solution_type==TransientSolutionEnum) output_value = dep->GetValue();
-		if(solution_type!=TransientSolutionEnum) dep->Responsex(&output_value,femmodel);
-		if (my_rank==0) {
-			output_value>>=dependents[i];
-			J+=output_value;
-		}
-	}
-
-	/*Turning off trace tape*/
+void simul_stoptrace(){/*{{{*/
+
+	#if defined(_HAVE_ADOLC_)
 	trace_off();
-time_t now = time(NULL);
-if(my_rank==0) _printf_("\nTIME: "<<now<<"\n");
-	/*Print tape statistics so that user can kill this run if something is off already:*/
 	if(VerboseAutodiff()){ /*{{{*/
+
+		#ifdef _HAVE_ADOLC_
+		int my_rank=IssmComm::GetRank();
 		size_t  tape_stats[15];
 		tapestats(my_rank,tape_stats); //reading of tape statistics
@@ -207,19 +148,171 @@
 		}
 		delete [] sstats;
+		#endif
+
+		#ifdef _HAVE_CODIPACK_
+		#ifdef _AD_TAPE_ALLOC_
+		//_printf_("Allocation time  P(" << my_rank << "): " << alloc_profiler.DeltaTime(StartInit, FinishInit) << "\n");
+		#endif
+		std::stringstream out_s;
+		IssmDouble::getGlobalTape().printStatistics(out_s);
+		_printf0_("CoDiPack Profiling::Tape Statistics :\n" << out_s.str());
+		#endif
 	} /*}}}*/
 
-	/*diverse: */
-	int  dummy;
-	int  num_independents=0;
+	#elif defined(_HAVE_CODIPACK_)
+	auto& tape_codi = IssmDouble::getGlobalTape();
+	tape_codi.setPassive();
+	if(VerboseAutodiff()){
+		int my_rank=IssmComm::GetRank();
+		if(my_rank == 0) {
+			// FIXME codi "just because" for now
+			tape_codi.printStatistics(std::cout);
+			codi_global.print(std::cout);
+		}
+	}
+	#else
+	_error_("not implemented");
+	#endif
+}/*}}}*/
+void simul_ad(long* indic,long* n,double* X,double* pf,double* G,long izs[1],float rzs[1],void* dzs){/*{{{*/
+
+	/*Get rank*/
+	int my_rank=IssmComm::GetRank();
+
+	/*Recover Arguments*/
+	m1qn3_struct *input_struct = (m1qn3_struct*)dzs;
+
+	FemModel* femmodel = input_struct->femmodel;
+	int num_responses,num_controls,solution_type;
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+
+	/*In transient, we need to make sure we do not modify femmodel at each iteration, make a copy*/
+	if(solution_type == TransientSolutionEnum) femmodel = input_struct->femmodel->copy();
+
+	IssmPDouble*  Jlist        = input_struct->Jlist;
+	int           JlistM       = input_struct->M;
+	int           JlistN       = input_struct->N;
+	int*          Jlisti       = input_struct->i;
+	int           intn         = (int)*n;
+
+	/*Recover some parameters*/
+	IssmDouble *scaling_factors = NULL;
+	int        *N               = NULL;
+	int        *control_enum    = NULL;
+	femmodel->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
+	femmodel->parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
+	femmodel->parameters->FindParam(&scaling_factors,NULL,InversionControlScalingFactorsEnum);
+	femmodel->parameters->FindParam(&N,NULL,ControlInputSizeNEnum);
+	femmodel->parameters->FindParam(&control_enum,NULL,InversionControlParametersEnum);
+	int numberofvertices=femmodel->vertices->NumberOfVertices();
+
+	/*Constrain input vector and update controls*/
+	double  *XL = NULL;
+	double  *XU = NULL;
+	GetPassiveVectorFromControlInputsx(&XL,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetPassiveVectorFromControlInputsx(&XU,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+
+	int N_add = 0;
+	for (int c=0;c<num_controls;c++){
+		for(int i=0;i<numberofvertices*N[c];i++){
+			int index = N_add*numberofvertices+i;
+			X[index] = X[index]*reCast<double>(scaling_factors[c]);
+			if(X[index]>XU[index]) X[index]=XU[index];
+			if(X[index]<XL[index]) X[index]=XL[index];
+		}
+		N_add+=N[c];
+	}
+
+	/*Start Tracing*/
+	simul_starttrace(femmodel);
+	/*Set X as our new control input and as INDEPENDENT*/
+#ifdef _HAVE_AD_
+	IssmDouble* aX=xNew<IssmDouble>(intn,"t");
+#else
+	IssmDouble* aX=xNew<IssmDouble>(intn);
+#endif
+
+	#if defined(_HAVE_ADOLC_)
+	if(my_rank==0){
+		for(int i=0;i<intn;i++){
+			aX[i]<<=X[i];
+		}
+	}
+	#elif defined(_HAVE_CODIPACK_)
+	auto& tape_codi = IssmDouble::getGlobalTape();
+	codi_global.input_indices.clear();
+	if(my_rank==0){
+		for (int i=0;i<intn;i++) {
+			aX[i]=X[i];
+			tape_codi.registerInput(aX[i]);
+			codi_global.input_indices.push_back(aX[i].getGradientData());
+		}
+	}
+	#else
+	_error_("not suppoted");
+	#endif
+
+	ISSM_MPI_Bcast(aX,intn,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+	SetControlInputsFromVectorx(femmodel,aX);
+	xDelete<IssmDouble>(aX);
+
+	/*Compute solution (forward)*/
+	void (*solutioncore)(FemModel*)=NULL;
+	CorePointerFromSolutionEnum(&solutioncore,femmodel->parameters,solution_type);
+	solutioncore(femmodel);
+
+	/*Reset the time to zero for next optimization*/
+	if(solution_type==TransientSolutionEnum){
+		IssmDouble restart_time;
+		femmodel->parameters->FindParam(&restart_time,TimesteppingStartTimeEnum);
+		femmodel->parameters->SetParam(restart_time,TimeEnum);
+
+	}
+
+	/*Get Dependents*/
+	IssmDouble  output_value;
+	int         num_dependents;
+	IssmPDouble *dependents;
+	DataSet*    dependent_objects=NULL;
+	IssmDouble	J=0.;
+	femmodel->parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
+	femmodel->parameters->FindParam(&dependent_objects,AutodiffDependentObjectsEnum);
+
+	/*Go through our dependent variables, and compute the response:*/
+	dependents=xNew<IssmPDouble>(num_dependents);
+	#if defined(_HAVE_CODIPACK_)
+	codi_global.output_indices.clear();
+	#endif
+	for(int i=0;i<dependent_objects->Size();i++){
+		DependentObject* dep=(DependentObject*)dependent_objects->GetObjectByOffset(i);
+		if(solution_type==TransientSolutionEnum) output_value = dep->GetValue();
+		if(solution_type!=TransientSolutionEnum) dep->Responsex(&output_value,femmodel);
+		if(my_rank==0) {
+
+			#if defined(_HAVE_CODIPACK_)
+			tape_codi.registerOutput(output_value);
+			dependents[i] = output_value.getValue();
+			codi_global.output_indices.push_back(output_value.getGradientData());
+
+			#elif defined(_HAVE_ADOLC_)
+			output_value>>=dependents[i];
+
+			#else
+			_error_("not suppoted");
+			#endif
+			J+=output_value;
+		}
+	}
+
+	/*Turning off trace tape*/
+	simul_stoptrace();
+	//time_t now = time(NULL);
+	//if(my_rank==0) _printf_("\nTIME: "<<now<<"\n");
 
 	/*intermediary: */
+	int          num_independents=intn;
 	IssmPDouble *aWeightVector=NULL;
 	IssmPDouble *weightVectorTimesJac=NULL;
-
-	/*output: */
-	IssmPDouble *totalgradient=NULL;
-
-	/*retrieve parameters: */
-	num_independents = intn;
+	IssmPDouble *totalgradient=xNewZeroInit<IssmPDouble>(num_independents);
 
 	/*if no dependents, no point in running a driver: */
@@ -229,4 +322,7 @@
 	int num_dependents_old   = num_dependents;
 	int num_independents_old = num_independents;
+
+	#if defined(_HAVE_ADOLC_)
+	/*Get gradient for ADOLC {{{*/
 	if(my_rank!=0){
 		num_dependents   = 0;
@@ -243,6 +339,4 @@
 	/* Ok, now we are going to call the fos_reverse in a loop on the index, from 0 to num_dependents, so
 	 * as to generate num_dependents gradients: */
-	totalgradient=xNewZeroInit<IssmPDouble>(num_independents_old);
-
 	for(int aDepIndex=0;aDepIndex<num_dependents_old;aDepIndex++){
 
@@ -277,4 +371,41 @@
 		xDelete(aWeightVector);
 	}
+	/*}}}*/
+	#elif defined(_HAVE_CODIPACK_)
+	/*Get gradient for CoDiPack{{{*/
+	if(VerboseAutodiff())_printf0_("   CoDiPack fos_reverse\n");
+
+	/* call the fos_reverse in a loop on the index, from 0 to num_dependents, so
+	 * as to generate num_dependents gradients: */
+	for(int aDepIndex=0;aDepIndex<num_dependents_old;aDepIndex++){
+
+		/*initialize direction index in the weights vector: */
+		aWeightVector=xNewZeroInit<IssmPDouble>(num_dependents);
+		if(my_rank==0){
+			if(aDepIndex<0 || aDepIndex>=num_dependents || codi_global.output_indices.size() <= aDepIndex){
+				_error_("index value for AutodiffFosReverseIndexEnum should be in [0,num_dependents-1]");
+			}
+			tape_codi.setGradient(codi_global.output_indices[aDepIndex],1.0);
+		}
+		tape_codi.evaluate();
+
+		/*Get gradient for this dependent */
+		weightVectorTimesJac=xNew<IssmPDouble>(num_independents);
+		auto in_size = codi_global.input_indices.size();
+		for(size_t i = 0; i < in_size; ++i) {
+			_assert_(i<num_independents);
+			weightVectorTimesJac[i] = tape_codi.getGradient(codi_global.input_indices[i]);
+		}
+		if(my_rank==0) for(int i=0;i<num_independents;i++) {
+			totalgradient[i]+=weightVectorTimesJac[i];
+		}
+		/*free resources :*/
+		xDelete(weightVectorTimesJac);
+		xDelete(aWeightVector);
+	}
+	/*}}}*/
+	#else
+	_error_("not suppoted");
+	#endif
 
 	/*Broadcast gradient to other ranks*/
@@ -293,10 +424,4 @@
 	Jlist[(*Jlisti)*JlistN+num_responses] = reCast<IssmPDouble>(J);
 
-/*
-	IssmDouble* test = xNew<IssmDouble>(intn);
-	femmodel->parameters->FindParam(&test,NULL,InversionXBestEnum);
-	for(int i=0;i<10;i++)_printf_("X "<<test[i]<<"\n");
-	xDelete<IssmDouble>(intn);
-*/
 	if(*indic==0){
 		/*dry run, no gradient required*/
@@ -341,4 +466,6 @@
 	xDelete<double>(XU);
 	xDelete<double>(XL);
+	xDelete<int>(control_enum);
+	xDelete<int>(N);
 	xDelete<IssmDouble>(scaling_factors);
 	xDelete<IssmPDouble>(totalgradient);
@@ -394,10 +521,5 @@
 
 	/*Get initial guess*/
-	Vector<double> *Xpetsc = NULL;
-
-	GetPassiveVectorFromControlInputsx(&Xpetsc,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"value");
-	X = Xpetsc->ToMPISerial();
-	Xpetsc->GetSize(&intn);
-	delete Xpetsc;
+	GetPassiveVectorFromControlInputsx(&X,&intn,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"value");
 	//_assert_(intn==numberofvertices*num_controls);
 
@@ -458,6 +580,6 @@
 	double  *XL = NULL;
 	double  *XU = NULL;
-	GetPassiveVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
-	GetPassiveVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	GetPassiveVectorFromControlInputsx(&XL,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetPassiveVectorFromControlInputsx(&XU,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
 
 	N_add = 0;
@@ -479,5 +601,5 @@
 		aX[i] = reCast<IssmDouble>(X[i]); 
 		aG[i] = reCast<IssmDouble>(G[i]);
-		}
+	}
 
 	ControlInputSetGradientx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,aG);
@@ -538,4 +660,4 @@
 
 #else
-void controladm1qn3_core(FemModel* femmodel){_error_("M1QN3 or ADOLC not installed");}
+void controladm1qn3_core(FemModel* femmodel){_error_("M1QN3 or ADOLC/CoDiPack not installed");}
 #endif //_HAVE_M1QN3_
